#import "IosDeviceCheckPlugin.h"
#import <DeviceCheck/DeviceCheck.h>

@implementation IosDeviceCheckPlugin

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
                                   methodChannelWithName:@"ios_device_check"
                                   binaryMessenger:[registrar messenger]];
  IosDeviceCheckPlugin* instance = [[IosDeviceCheckPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if (@available(iOS 11, *)) {
    if ([@"isSupported" isEqualToString:call.method]) {
      result(@([[DCDevice currentDevice] isSupported]));
    } else if ([@"generateToken" isEqualToString:call.method]) {
      [[DCDevice currentDevice] generateTokenWithCompletionHandler:^(NSData* token, NSError* error) {
        if (error) {
          result([FlutterError
                  errorWithCode:[NSString stringWithFormat:@"Error: %d", (int)error.code]
                  message:error.domain
                  details:error.localizedDescription]);
        } else {
          result([token base64EncodedStringWithOptions:0]);
        }
      }];
    } else {
      result(FlutterMethodNotImplemented);
    }
  } else {
    result([FlutterError
            errorWithCode:@""
            message:@""
            details:@""]);
  }
}

@end
